package com.sa.ibiz.demo.demo.service.impl;

import java.util.List;
import javax.annotation.Resource;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.demo.mapper.UserRoleResMapper;
import com.sa.ibiz.demo.demo.domain.UserRoleRes;
import com.sa.ibiz.demo.demo.service.UserRoleResService;
import com.sa.ibiz.demo.ibizutil.service.ServiceImplBase;
import com.sa.ibiz.demo.demo.service.dto.UserRoleResSearchFilter;
import org.springframework.util.DigestUtils;
import org.springframework.util.StringUtils;
import java.util.UUID;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import java.util.TreeMap;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import java.math.BigInteger;
import com.sa.ibiz.demo.ibizutil.annotation.PreField;
import java.lang.reflect.Field;

import com.sa.ibiz.demo.demo.service.UniResService;
import com.sa.ibiz.demo.demo.service.UserRoleService;

/**
 * 实体[UserRoleRes] 服务对象接口实现
 */
@Service
public class UserRoleResServiceImpl extends ServiceImplBase<UserRoleResMapper, UserRoleRes> implements UserRoleResService{

    @Autowired
    private UniResService uniresService;
    @Autowired
    private UserRoleService userroleService;

    @Resource
    private UserRoleResMapper userroleresMapper;


    @Override
    public boolean create(UserRoleRes et) {
        this.beforeCreate(et);
        String primaryKey=et.getUserroleresid();
        if(StringUtils.isEmpty(primaryKey))
        {
            primaryKey=(String)et.getDefaultPrimaryKey();
            et.setUserroleresid(primaryKey);
         }
         return super.create(et);
    }
    @Override
	public UserRoleRes get(UserRoleRes et) {
        String primaryKey=et.getUserroleresid();
         if(StringUtils.isEmpty(primaryKey))
         {
             primaryKey=(String)et.getDefaultPrimaryKey();
             et.setUserroleresid(primaryKey);
          }
		      return super.get(et);
	}

    @Override
   	public boolean remove(UserRoleRes et) {
        String primaryKey=et.getUserroleresid();
         if(StringUtils.isEmpty(primaryKey))
         {
             primaryKey=(String)et.getDefaultPrimaryKey();
             et.setUserroleresid(primaryKey);
          }
   		     return super.remove(et);
   	}

    @Override
    public boolean update(UserRoleRes et){
        String primaryKey=et.getUserroleresid();
         if(StringUtils.isEmpty(primaryKey))
         {
             primaryKey=(String)et.getDefaultPrimaryKey();
             et.setUserroleresid(primaryKey);
          }
		     this.userroleresMapper.updateOne(et);
		     this.get(et);
             return true;
    }


    public Object getEntityKey(UserRoleRes et){
		return et.getUserroleresid();  
    }

    @Override
    public boolean getDraft(UserRoleRes et)  {
    if((!StringUtils.isEmpty(et.getUniresid())) && et.getUnires() == null){
            try {
                et.setUnires(uniresService.getById(et.getUniresid()));
            }catch (Exception ex){}
        }
    if((!StringUtils.isEmpty(et.getUserroleid())) && et.getUserrole() == null){
            try {
                et.setUserrole(userroleService.getById(et.getUserroleid()));
            }catch (Exception ex){}
        }
            return true;
    }

	public List<UserRoleRes> listDefault(UserRoleResSearchFilter filter) {
		return userroleresMapper.searchDefault(filter,filter.getSelectCond());
	}

	public Page<UserRoleRes> searchDefault(UserRoleResSearchFilter filter) {
		return userroleresMapper.searchDefault(filter.getPage(),filter,filter.getSelectCond());
	}

    public  List<Map<String,Object>> selectRow(String sql){
       return userroleresMapper.selectRow(sql);
    }

 }